aboutsummaryrefslogtreecommitdiff
path: root/zsh/.zsh/prompt.zsh
diff options
context:
space:
mode:
Diffstat (limited to 'zsh/.zsh/prompt.zsh')
-rw-r--r--zsh/.zsh/prompt.zsh74
1 files changed, 67 insertions, 7 deletions
diff --git a/zsh/.zsh/prompt.zsh b/zsh/.zsh/prompt.zsh
index 4203929..cf1b525 100644
--- a/zsh/.zsh/prompt.zsh
+++ b/zsh/.zsh/prompt.zsh
@@ -13,21 +13,69 @@
# ░▓ mirror ▓ http://git.io/.files
# ░▓▓▓▓▓▓▓▓▓▓
# ░░░░░░░░░░
+autoload -U compinit colors zcalc
+compinit -d
+colors
-#ICO_DIRTY="⚡"
+ICO_DIRTY="⚡"
#ICO_DIRTY="↯"
-ICO_DIRTY="*"
-#ICO_AHEAD="↑"
-ICO_AHEAD="🠙"
+#ICO_DIRTY="*"
+ICO_AHEAD="↑"
+#ICO_AHEAD="🠙"
#ICO_AHEAD="▲"
-#ICO_BEHIND="↓"
-ICO_BEHIND="🠛"
+ICO_BEHIND="↓"
+#ICO_BEHIND="🠛"
#ICO_BEHIND="▼"
ICO_DIVERGED="⥮"
COLOR_ROOT="%F{red}"
COLOR_USER="%F{cyan}"
COLOR_NORMAL="%F{white}"
PROMPT_STYLE="classic"
+# Modify the colors and symbols in these variables as desired.
+GIT_PROMPT_SYMBOL="%{$fg[blue]%}±" # plus/minus - clean repo
+GIT_PROMPT_PREFIX="%{$fg[green]%} %{$reset_color%}"
+GIT_PROMPT_SUFFIX="%{$fg[green]%}%{$reset_color%}"
+GIT_PROMPT_AHEAD="%{$fg[red]%}ANUM%{$reset_color%}" # A"NUM" - ahead by "NUM" commits
+GIT_PROMPT_BEHIND="%{$fg[cyan]%}BNUM%{$reset_color%}" # B"NUM" - behind by "NUM" commits
+GIT_PROMPT_MERGING="%{$fg_bold[magenta]%}⚡%{$reset_color%}" # lightning bolt - merge conflict
+GIT_PROMPT_UNTRACKED="%{$fg_bold[red]%}●%{$reset_color%}" # red circle - untracked files
+GIT_PROMPT_MODIFIED="%{$fg_bold[yellow]%}●%{$reset_color%}" # yellow circle - tracked files modified
+GIT_PROMPT_STAGED="%{$fg_bold[green]%}●%{$reset_color%}" # green circle - staged changes present = ready for "git push"
+
+parse_git_branch() {
+ # Show Git branch/tag, or name-rev if on detached head
+ ( git symbolic-ref -q HEAD || git name-rev --name-only --no-undefined --always HEAD ) 2> /dev/null
+}
+
+parse_git_state() {
+ # Show different symbols as appropriate for various Git repository states
+ # Compose this value via multiple conditional appends.
+ local GIT_STATE=""
+ local NUM_AHEAD="$(git log --oneline @{u}.. 2> /dev/null | wc -l | tr -d ' ')"
+ if [ "$NUM_AHEAD" -gt 0 ]; then
+ GIT_STATE=$GIT_STATE${GIT_PROMPT_AHEAD//NUM/$NUM_AHEAD}
+ fi
+ local NUM_BEHIND="$(git log --oneline ..@{u} 2> /dev/null | wc -l | tr -d ' ')"
+ if [ "$NUM_BEHIND" -gt 0 ]; then
+ GIT_STATE=$GIT_STATE${GIT_PROMPT_BEHIND//NUM/$NUM_BEHIND}
+ fi
+ local GIT_DIR="$(git rev-parse --git-dir 2> /dev/null)"
+ if [ -n $GIT_DIR ] && test -r $GIT_DIR/MERGE_HEAD; then
+ GIT_STATE=$GIT_STATE$GIT_PROMPT_MERGING
+ fi
+ if [[ -n $(git ls-files --other --exclude-standard 2> /dev/null) ]]; then
+ GIT_STATE=$GIT_STATE$GIT_PROMPT_UNTRACKED
+ fi
+ if ! git diff --quiet 2> /dev/null; then
+ GIT_STATE=$GIT_STATE$GIT_PROMPT_MODIFIED
+ fi
+ if ! git diff --cached --quiet 2> /dev/null; then
+ GIT_STATE=$GIT_STATE$GIT_PROMPT_STAGED
+ fi
+ if [[ -n $GIT_STATE ]]; then
+ echo "$GIT_PROMPT_PREFIX$GIT_STATE$GIT_PROMPT_SUFFIX"
+ fi
+}
#█▓▒░ allow functions in the prompt
@@ -42,6 +90,17 @@ else # root!
USER_LEVEL="${COLOR_ROOT}"
fi
+git_prompt_string() {
+ local git_where="$(parse_git_branch)"
+
+ # If inside a Git repository, print its branch and state
+ [ -n "$git_where" ] && echo "$GIT_PROMPT_SYMBOL$(parse_git_state)$GIT_PROMPT_PREFIX%{$fg[yellow]%}${git_where#(refs/heads/|tags/)}$GIT_PROMPT_SUFFIX"
+
+ # If not inside the Git repo, print exit codes of last command (only if it failed)
+ [ ! -n "$git_where" ] && echo "%{$fg[red]%}%(?..%?)"
+}
+
+
#█▓▒░ git prompt
GIT_PROMPT() {
test=$(git rev-parse --is-inside-work-tree 2> /dev/null)
@@ -116,6 +175,7 @@ ${USER_LEVEL}└─ - %f'
;;
#█▓▒░ classic
*)
-PROMPT='${USER_LEVEL}[${COLOR_NORMAL}%~${USER_LEVEL}]$(GIT_PROMPT)── - %f'
+PROMPT='%F{cyan}┌─[$USER@$HOST]─[$(git_prompt_string)${USER_LEVEL}]─[${COLOR_NORMAL}%~${USER_LEVEL}]
+└─ - %f'
;;
esac